<?php

namespace VfxApply;

class Dialog
{
    protected $title;

    public function __construct($title=null)
    {
        $this->title = $title;
    }

    public function __destruct()
    {
        $this->onDestroy();
    }

    public function show()
    {
        $this->onCreate();
    }

    protected function onCreate()
    {}

    protected function onDestroy()
    {}
}